//-----------------------------------------------------------------------------
//	CANRlN^iC8420j								A.Fukumori	2007/10/26
//
//-----------------------------------------------------------------------------
// ڑdl
//
//	------ CN3 ---------	------ CN4 ---------	
//													
//	10	A-		GND			1	----	----		
//	9	A+		----		2	P6-0	----		
//	8	P5-0	TxD			3	P6-1	----		
//	7	P5-1	RxD			4	P6-2	----		
//	6	P5-2	Test		5	P6-3	----		
//	5	P5-3	----		6	P6-4	----		
//	4	P5-4	----		7	P6-5	----		
//	3	P5-5	----		8	P6-6	----		
//	2	P5-6	----		9	P6-7	----		
//	1	P5-7	----		10	GND		----		
//
//-----------------------------------------------------------------------------
// MEMO
//
//	300->124usec 240->98usec 252->104usec
//	63->27.4usec 60->27.2usec 50->24usec 55->25.6 56->25.8
//
//-----------------------------------------------------------------------------
//#include "iodefine.h"


//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
extern void CAN_Command_Read(unsigned char id);


//-----------------------------------------------------------------------------
//	W[p֐Q
//-----------------------------------------------------------------------------
int C8420_Init(unsigned int dly);
void C8420_SetTxD(unsigned char bit);
unsigned char C8420_GetRxD(void);
void C8420_SetTEST(unsigned char bit);
void C8420_Wait(unsigned int dly);
void C8420_Put(unsigned char data);
unsigned char C8420_Get(void);


//-----------------------------------------------------------------------------
//	OC^[tF[X֐Q
//-----------------------------------------------------------------------------
void Raed_ID_C8420_MODE(void);
void Raed_ID_C8420_POL_L(void);
void Raed_ID_C8420_POL_H(void);
void Raed_ID_C8420_INT_L(void);
void Raed_ID_C8420_INT_H(void);
void Raed_ID_C8420_S(void);
void Raed_ID_C8420_SEND(void);
void Write_ID_C8420_MODE(unsigned char low ,unsigned char hi);
void Write_ID_C8420_POL_L(unsigned char low ,unsigned char hi);
void Write_ID_C8420_POL_H(unsigned char low ,unsigned char hi);
void Write_ID_C8420_INT_L(unsigned char low ,unsigned char hi);
void Write_ID_C8420_INT_H(unsigned char low ,unsigned char hi);
void Write_ID_C8420_S(unsigned char low ,unsigned char hi);
void Write_ID_C8420_SEND(unsigned char low ,unsigned char hi);


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
//unsigned int C8420_Delay = 252Ⴄ;	//  9600bps(=104usec)
unsigned int C8420_Delay = 42;		// 38400bps(=26usec)


//-----------------------------------------------------------------------------
//	C^[tF[X̏
//-----------------------------------------------------------------------------
int C8420_Init(unsigned int dly)
{
	//|[g̏s
	IO.PCR5			= 0xFD;	// 1111 1101	Configure port P5
	IO.PDR5.BYTE	= 0x00;	// 0000 0000	Initialize port P5
	C8420_Delay		= dly;
	return 0;
}

//-----------------------------------------------------------------------------
//	rbgM
//-----------------------------------------------------------------------------
void C8420_SetTxD(unsigned char bit)
{
	if(bit)
		IO.PDR5.BYTE |= 0x01;
	else
		IO.PDR5.BYTE &= 0xFE;
}

//-----------------------------------------------------------------------------
//	rbgMi]Ď擾j
//-----------------------------------------------------------------------------
unsigned char C8420_GetRxD(void)
{
	if(IO.PDR5.BYTE & 0x02)	// RxD̃rbgMSBɃZbg
	return 0x00;
	return 0x80;
}

//-----------------------------------------------------------------------------
//	rbgM
//-----------------------------------------------------------------------------
void C8420_SetTEST(unsigned char bit)
{
	if(bit)
		IO.PDR5.BYTE |= 0x04;	// 0100
	else
		IO.PDR5.BYTE &= 0xFB;
}

//-----------------------------------------------------------------------------
//	EGCg
//-----------------------------------------------------------------------------
void C8420_Wait(unsigned int dly)
{
	while(dly) dly--;
}

//-----------------------------------------------------------------------------
//	oCgM											A.Fukumori	2007/10/22
//-----------------------------------------------------------------------------
void C8420_Put(unsigned char data)
{
	unsigned char put[11];

	put[0]	= 0;					// X^[grbg
	C8420_SetTxD(put[0]);			// X^[grbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[1]	= (data>>0)&0x01;		// f[^LSB
	C8420_SetTxD(put[1]);			// f[^LSBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[2]	= (data>>1)&0x01;		// 
	C8420_SetTxD(put[2]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[3]	= (data>>2)&0x01;		// 
	C8420_SetTxD(put[3]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[4]	= (data>>3)&0x01;		// 
	C8420_SetTxD(put[4]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[5]	= (data>>4)&0x01;		// 
	C8420_SetTxD(put[5]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[6]	= (data>>5)&0x01;		// 
	C8420_SetTxD(put[6]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[7]	= (data>>6)&0x01;		// 
	C8420_SetTxD(put[7]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[8]	= (data>>7)&0x01;		// f[^MSB
	C8420_SetTxD(put[8]);			// f[^MSBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[9]	= (1+put[1]+put[2]+put[3]+put[4]+put[5]+put[6]+put[7]+put[8])&0x01;
	C8420_SetTxD(put[9]);			// peBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	put[10]	= 1;					// Xgbvrbg
	C8420_SetTxD(put[10]);			// XgbvrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	return;
}
/*
//-----------------------------------------------------------------------------
//	oCgM
//-----------------------------------------------------------------------------
void C8420_Put(unsigned char data)
{
	unsigned char put[11];
	
	put[0]	= 0;					// X^[grbg
	put[1]	= (data>>0)&0x01;		// f[^LSB
	put[2]	= (data>>1)&0x01;		// 
	put[3]	= (data>>2)&0x01;		// 
	put[4]	= (data>>3)&0x01;		// 
	put[5]	= (data>>4)&0x01;		// 
	put[6]	= (data>>5)&0x01;		// 
	put[7]	= (data>>6)&0x01;		// 
	put[8]	= (data>>7)&0x01;		// f[^MSB
	put[9]	= 1+put[1]+put[2]+put[3]+put[4]+put[5]+put[6]+put[7]+put[8];
	put[9]	= put[9]&0x01;			// peBrbg
	put[10]	= 1;					// Xgbvrbg
	
	C8420_SetTxD(put[0]);			// X^[grbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[1]);			// f[^LSBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[2]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[3]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[4]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[5]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[6]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[7]);			// rbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[8]);			// f[^MSBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[9]);			// peBrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	C8420_SetTxD(put[10]);			// XgbvrbgM
	C8420_Wait(C8420_Delay);		// PNbÑEGCg
	return;
}
*/

//-----------------------------------------------------------------------------
//	oCgM
//-----------------------------------------------------------------------------
unsigned char C8420_Get(void)
{
	unsigned char data;

	while(C8420_GetRxD());			// X^[grbg҂@̋Lq͊댯I
	C8420_Wait(10);					// PNbÑEGCg
	data = 0x00;					// rbg̒Sǂݍނ߁A
	C8420_SetTEST(1);
	C8420_Wait(C8420_Delay);		// PNbÑEGCgiX^[grbgj
	data >>=1;						// f[^LSBɓǂݍނ߂PrbgVtg
	data |= C8420_GetRxD();			// f[^LSBrbgM
	C8420_SetTEST(0);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(1);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(0);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(1);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(0);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(1);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// rbgM
	C8420_SetTEST(0);
	C8420_Wait(C8420_Delay);		// 
	data >>=1;						// 
	data |= C8420_GetRxD();			// f[^MSBrbgM
	C8420_SetTEST(1);
	C8420_Wait(C8420_Delay);		// 
									// peBrbg
	C8420_SetTEST(0);
	C8420_Wait(C8420_Delay);		// 
									// Xgbvrbg
//	C8420_SetTEST(1);
//	C8420_Wait(C8420_Delay/2);		// 
//	C8420_SetTEST(0);
	return data;
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_MODE(void)
{
	
}

//-----------------------------------------------------------------------------
//	`FbNpi25msecԊȗMɂȂ̂ŒӁj	A.Fukumori	2007/10/26
//-----------------------------------------------------------------------------
void Raed_ID_C8420_POL_L(void)
{
	unsigned long	data1;	// [mm]
	unsigned int	data2;	// [-]
	unsigned char	get[10];

	if(!(ICN[ID_MODE].DATA.BYTE.B1==ID_C8420_MODE)) return;

//	C8420_Put('S');				// mFp
//	C8420_Put(0x0D);			// mFp
	while(C8420_Get()!='S');	// 'S' = 0x53 X^[gf[^҂
	get[0] = C8420_Get();		// 'X'
	get[1] = C8420_Get();		// 'X'
	get[2] = C8420_Get();		// 'X'
	get[3] = C8420_Get();		// 'X'
	get[4] = C8420_Get();		// 'X'
	get[5] = C8420_Get();		// ',' = 0x2C
	get[6] = C8420_Get();		// 'X'
	get[7] = C8420_Get();		// 'X'
	get[8] = C8420_Get();		// 'X'
	get[9] = C8420_Get();		// '\r'= 0x0D
	data1  = (get[0]==' ') ? 0:(unsigned long)(get[0]-'0')*100000;	// 100000
	data1 += (get[1]==' ') ? 0:(unsigned long)(get[1]-'0')*10000;	// 10000
	data1 += (get[2]==' ') ? 0:(unsigned long)(get[2]-'0')*1000;	// 1000
	data1 += (get[3]==' ') ? 0:(unsigned long)(get[3]-'0')*100;		// 100
	data1 += (get[4]==' ') ? 0:(unsigned long)(get[4]-'0')*10;		// 10/[mm]
	data2  = (get[6]==' ') ? 0:(get[6]-'0')*100;	// 100
	data2 += (get[7]==' ') ? 0:(get[7]-'0')*10;		// 10
	data2 += (get[8]==' ') ? 0:(get[8]-'0')*1;		// 1/[-]
	if((get[5]==0x2C)&&(get[9]==0x0D))
	{
		ICN[ID_C8420_POL_L].DATA.DWORD.D1 = data1;
		ICN[ID_C8420_POL_H].DATA.WORD.W1 = ICN[ID_C8420_POL_L].DATA.WORD.W2;
		ICN[ID_C8420_S].DATA.WORD.W1 = data2;			// [-]
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_POL_H(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_INT_L(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_INT_H(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_S(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_C8420_SEND(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_MODE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==0)
	{
		ICN[ID_C8420_MODE].DATA.BYTE.B1 = low;
		ICN[ID_C8420_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_C8420_MODE].DATA.WORD.W1)
		{
			ICN[ID_MODE].DATA.BYTE.B1 = ID_C8420_MODE;
			C8420_Init(ICN[ID_C8420_MODE].DATA.WORD.W1);
		}
	}
	else if(ICN[ID_MODE].DATA.BYTE.B1 == ID_C8420_MODE)
	{
		ICN[ID_C8420_MODE].DATA.BYTE.B1 = low;
		ICN[ID_C8420_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_C8420_MODE].DATA.WORD.W1==0)
		{
			ICN[ID_MODE].DATA.BYTE.B1	= 0;
			ICN[ID_P5_PU].DATA.BYTE.B1	= IO.PUCR5.BYTE;
			ICN[ID_P5_PC].DATA.BYTE.B1	= IO.PCR5;
			ICN[ID_P5_DI].DATA.BYTE.B1	= IO.PDR5.BYTE;
			ICN[ID_P5_DO].DATA.BYTE.B1	= IO.PDR5.BYTE;
		}
		else
		{
			C8420_Delay = ICN[ID_C8420_MODE].DATA.WORD.W1;
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_POL_L(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_POL_H(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_INT_L(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_INT_H(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_S(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_C8420_SEND(unsigned char low ,unsigned char hi)
{
	if(!(ICN[ID_MODE].DATA.BYTE.B1==ID_C8420_MODE)) return;

	ICN[ID_C8420_SEND].DATA.BYTE.B1 = low;
	ICN[ID_C8420_SEND].DATA.BYTE.B2 = 0;
	C8420_Put(low);
}

//-----------------------------------------------------------------------------
//	C8420 p[v									A.Fukumori	2007/11/09
//-----------------------------------------------------------------------------
int C8420_Loop(void)
{
	unsigned long	data1;	// [mm]
	unsigned int	data2;	// [-]
	unsigned char	get[10];

	if(!(ICN[ID_MODE].DATA.BYTE.B1==ID_C8420_MODE)) return 0;

	// 0usec,25000usec
	while(C8420_Get()!='S');	// 'S' = 0x53 X^[gf[^҂
	get[0] = C8420_Get();		// 'X'
	get[1] = C8420_Get();		// 'X'
	get[2] = C8420_Get();		// 'X'
	get[3] = C8420_Get();		// 'X'
	get[4] = C8420_Get();		// 'X'
	get[5] = C8420_Get();		// ',' = 0x2C
	get[6] = C8420_Get();		// 'X'
	get[7] = C8420_Get();		// 'X'
	get[8] = C8420_Get();		// 'X'
	get[9] = C8420_Get();		// '\r'= 0x0D
	// 26usec*11bit*11=3146usec
	data1  = (get[0]==' ') ? 0:(unsigned long)(get[0]-'0')*100000;	// 100000
	data1 += (get[1]==' ') ? 0:(unsigned long)(get[1]-'0')*10000;	// 10000
	data1 += (get[2]==' ') ? 0:(unsigned long)(get[2]-'0')*1000;	// 1000
	data1 += (get[3]==' ') ? 0:(unsigned long)(get[3]-'0')*100;		// 100
	data1 += (get[4]==' ') ? 0:(unsigned long)(get[4]-'0')*10;		// 10/[mm]
	data2  = (get[6]==' ') ? 0:(get[6]-'0')*100;	// 100
	data2 += (get[7]==' ') ? 0:(get[7]-'0')*10;		// 10
	data2 += (get[8]==' ') ? 0:(get[8]-'0')*1;		// 1/[-]
	if((get[5]==0x2C)&&(get[9]==0x0D))
	{
		ICN[ID_C8420_INT_L].DATA.DWORD.D1 = data1;
		ICN[ID_C8420_INT_H].DATA.WORD.W1 = ICN[ID_C8420_INT_L].DATA.WORD.W2;
		ICN[ID_C8420_S].DATA.WORD.W1 = data2;			// [-]
	}
	WDT.TMWD.BIT.CKS = 0x0E;	// NbNZNg
	WDT.TCSRWD.BYTE = 0x5A;		// ^C}Rg[^Xe[^XWX^WD
	WDT.TCSRWD.BYTE = 0x56;		// EHb`hbO^C}I
	WDT.TCWD = 0;
	while(WDT.TCWD<100)	// (25000-3146-0.05*4096*100=1374usec)
	{
		CAN_Receive_Send();		// 500usec
	}
	WDT.TCSRWD.BYTE = 0x5A;		// ^C}Rg[^Xe[^XWX^WD
	WDT.TCSRWD.BYTE = 0x52;		// EHb`hbO^C}It
	return 0;
}
