//-----------------------------------------------------------------------------
//	CANRlN^iDAC8531j								A.Fukumori	2007/11/29
//
//-----------------------------------------------------------------------------
// ڑdl
//
//	------ CN3 ---------	------ CN4 ---------	
//													
//	10	A-		GND			1	----	----		
//	9	A+		----		2	P6-0	----		
//	8	P5-0	DATA		3	P6-1	----		
//	7	P5-1	SCLK		4	P6-2	----		
//	6	P5-2	nSYNC		5	P6-3	----		
//	5	P5-3	----		6	P6-4	----		
//	4	P5-4	----		7	P6-5	----		
//	3	P5-5	----		8	P6-6	----		
//	2	P5-6	----		9	P6-7	----		
//	1	P5-7	----		10	GND		----		
//
//-----------------------------------------------------------------------------
//#include "iodefine.h"


//-----------------------------------------------------------------------------
//	C^[tF[X֐Q
//-----------------------------------------------------------------------------
void DA_DATA_SET(unsigned short data );


//-----------------------------------------------------------------------------
//	OC^[tF[X֐Q
//-----------------------------------------------------------------------------
void Raed_ID_DAC8531_MODE(void);
void Raed_ID_DAC8531_DATA(void);
void Write_ID_DAC8531_MODE(unsigned char low ,unsigned char hi);
void Write_ID_DAC8531_DATA(unsigned char low ,unsigned char hi);


//-----------------------------------------------------------------------------
//	DAC8531֐
//-----------------------------------------------------------------------------
void DA_DATA_SET(unsigned short data )
{
	unsigned char i;

	IO.PDR5.BIT.B2 = 1;					// P52:SYNC/ => HIGH
	IO.PDR5.BIT.B2 = 0;					// P52:SYNC/ => LOW

	// header 8bit o
	for(i=0; i<8; i++)					// PD1=0,PD0=0
	{
		IO.PDR5.BIT.B1 = 1;				// P51:SCLK  => HIGH
		IO.PDR5.BIT.B0 = 0;				// P50:DATA  => LOW
		IO.PDR5.BIT.B1 = 0;				// P51:SCLK  => LOW
	}

	// data 16bit o
	// MSBo
	for(i=0; i<16; i++)
	{
		IO.PDR5.BIT.B1 = 1;				// P51:SCLK  => HIGH
		if(data & 0x8000)
		{
			IO.PDR5.BIT.B0 = 1;			// P50:DATA  => HIGH
		}
		else
		{
			IO.PDR5.BIT.B0 = 0;			// P50:DATA  => LOW
		}
		IO.PDR5.BIT.B1 = 0;				// P51:SCLK  => LOW
		data = data << 1;
	}

	IO.PDR5.BIT.B1 = 1;					// P51:SCLK  => HIGH
	IO.PDR5.BIT.B2 = 1;					// P52:SYNC/ => HIGH
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_DAC8531_MODE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_DAC8531_DATA(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_DAC8531_MODE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==0)
	{
		ICN[ID_DAC8531_MODE].DATA.BYTE.B1 = low;
		ICN[ID_DAC8531_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_DAC8531_MODE].DATA.WORD.W1)
		{
			IO.PUCR5.BYTE				= 0x00;		// 0000 0000
			IO.PCR5						= 0x07;		// 0000 0111 (0:in 1:out)
			IO.PDR5.BYTE				= 0x06;		// 0000 0110
			ICN[ID_MODE].DATA.BYTE.B1	= ID_DAC8531_MODE;
			ICN[ID_P5_PU].DATA.BYTE.B1	= IO.PUCR5.BYTE;
			ICN[ID_P5_PC].DATA.BYTE.B1	= IO.PCR5;
			ICN[ID_P5_DI].DATA.BYTE.B1	= IO.PDR5.BYTE;
			ICN[ID_P5_DO].DATA.BYTE.B1	= IO.PDR5.BYTE;
		}
	}
	else if(ICN[ID_MODE].DATA.BYTE.B1 == ID_DAC8531_MODE)
	{
		ICN[ID_DAC8531_MODE].DATA.BYTE.B1 = low;
		ICN[ID_DAC8531_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_DAC8531_MODE].DATA.WORD.W1==0)
		{
			ICN[ID_MODE].DATA.BYTE.B1	= 0;
			ICN[ID_P5_PU].DATA.BYTE.B1	= IO.PUCR5.BYTE;
			ICN[ID_P5_PC].DATA.BYTE.B1	= IO.PCR5;
			ICN[ID_P5_DI].DATA.BYTE.B1	= IO.PDR5.BYTE;
			ICN[ID_P5_DO].DATA.BYTE.B1	= IO.PDR5.BYTE;
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_DAC8531_DATA(unsigned char low ,unsigned char hi)
{
	if(!(ICN[ID_MODE].DATA.BYTE.B1==ID_DAC8531_MODE)) return;

	ICN[ID_DAC8531_DATA].DATA.BYTE.B1 = low;
	ICN[ID_DAC8531_DATA].DATA.BYTE.B2 = 0;
	DA_DATA_SET(low);
}
