//-----------------------------------------------------------------------------
//	CANRlN^iMCWj275								A.Fukumori	2007/07/24
//
//	gWX^ZpQOOUNUQlɂB
//-----------------------------------------------------------------------------
// ڑdl
//
//	------ CN3 ---------	------ CN4 ---------	
//													
//	10	A-		GND			1	----	----		
//	9	A+		----		2	P6-0	----		
//	8	P5-0	DO			3	P6-1	----		
//	7	P5-1	DI			4	P6-2	----		
//	6	P5-2	SK			5	P6-3	----		
//	5	P5-3	CS			6	P6-4	----		
//	4	P5-4	----		7	P6-5	----		
//	3	P5-5	----		8	P6-6	----		
//	2	P5-6	----		9	P6-7	----		
//	1	P5-7	----		10	GND		----			
//
//-----------------------------------------------------------------------------
//#include "iodefine.h"      

#define	BIT_DO	0x0001
#define	BIT_DI	0x0002
#define	BIT_CLK	0x0004
#define	BIT_CS	0x0008

//-----------------------------------------------------------------------------
//	W֐
//-----------------------------------------------------------------------------
int				MCW_Init		(void);				// C^[tF[X̏
void			MCW_SendData	(char dat ,char cnt);	// f[^̑M
char			MCW_RecvData	(char cnt);			// f[^̎M

//-----------------------------------------------------------------------------
//	g֐
//-----------------------------------------------------------------------------
unsigned int	MCW_EEP_read	(unsigned char adr);
unsigned int	MCW_EEP_ewen	(void);
unsigned int	MCW_EEP_erase	(unsigned char adr);
unsigned int	MCW_EEP_write	(unsigned char adr ,
								 unsigned char low ,unsigned char hi);
unsigned int	MCW_EEP_eral	(void);
unsigned int	MCW_EEP_wral	(unsigned char low ,unsigned char hi);
unsigned int	MCW_EEP_ewds	(void);

//-----------------------------------------------------------------------------
//	p֐
//-----------------------------------------------------------------------------
void			MCW_ClkCnt		(char sbit);	// CLKrbg̑
void			MCW_DatCnt		(char sbit);	// DATrbg̑
void			MCW_CsCnt		(char sbit);	// CSrbg̑
char			MCW_DatChk		(void);			// DATrbg̓ǂݍ


//-----------------------------------------------------------------------------
//	C^[tF[X̏
//-----------------------------------------------------------------------------
int MCW_Init(void)
{
	//|[g̏s
	//Configure port P5
	IO.PCR5			= 0xFE;	// 1111 1110
	//Initialize port P5
	IO.PDR5.BYTE	= 0x00;	// 0000 0000

	MCW_CsCnt(0);
	MCW_ClkCnt(0);
	MCW_DatCnt(0);
	return 0;
}

//-----------------------------------------------------------------------------
//	CLKrbg̑
//-----------------------------------------------------------------------------
void MCW_ClkCnt(char sbit)
{
	if (sbit) {
		IO.PDR5.BYTE |= BIT_CLK;
	} else {
		IO.PDR5.BYTE &= ~BIT_CLK;
	}
}

//-----------------------------------------------------------------------------
//	DATrbg̑
//-----------------------------------------------------------------------------
void MCW_DatCnt(char sbit)
{
	if (sbit){
		IO.PDR5.BYTE |= BIT_DI;
	}else{
		IO.PDR5.BYTE &= ~BIT_DI;
	}
}

//-----------------------------------------------------------------------------
//	CSrbg̑
//-----------------------------------------------------------------------------
void MCW_CsCnt(char sbit)
{
	if (sbit) {
		IO.PDR5.BYTE |= BIT_CS;
	} else {
		IO.PDR5.BYTE &= ~BIT_CS;
	}
}

//-----------------------------------------------------------------------------
//	DATrbg̓ǂݍ
//-----------------------------------------------------------------------------
char MCW_DatChk(void)
{
	char	ret = 0x00;
	
	if (IO.PDR5.BYTE & BIT_DO){
		ret = 0x01;
	}
	return ret;
}

//-----------------------------------------------------------------------------
//	f[^̑M
//-----------------------------------------------------------------------------
void MCW_SendData(char dat,char cnt)
{
	//f[^rbgʃrbgAcntrbgM
	while(cnt){
		if(dat & 0x80){
			MCW_DatCnt(1);
		}else{
			MCW_DatCnt(0);
		}
		//CLK̔s
		MCW_ClkCnt(1);
		MCW_ClkCnt(0);
		dat <<=1;
		cnt--;
	}
}

//-----------------------------------------------------------------------------
//	f[^̎M
//-----------------------------------------------------------------------------
char MCW_RecvData(char cnt)
{
	//ʃrbg瑗Mꂽf[^AcntrbgM
	char dat;
	dat=0;
	while(cnt){
		dat <<=1;
		MCW_ClkCnt(1);
		MCW_ClkCnt(0);
		if(MCW_DatChk())
			dat|=1;
		cnt--;
	}
	return dat;
}


//=============================================================================
//	MicrowirefoCX̓ǂݏ֐
//=============================================================================
//-----------------------------------------------------------------------------
// MicrowirefoCX̓ǂݍ݁A16rbg̃f[^ǂݏo(93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_read(unsigned char adr)
{
	char cmd;
	unsigned char low;
	unsigned char hi;

	cmd=(adr & 0x3f) | 0x80;	//0x80́AReadR}h
	//MicrowirefoCX̎wAhX̃f[^ǂݍ
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	//f[^̎M
	hi=MCW_RecvData(8);
	low=MCW_RecvData(8);
	MCW_CsCnt(0);	//CS=L
	return ((unsigned int)(hi))<<8|low;
}

//-----------------------------------------------------------------------------
//	MicrowirefoCX̏݋ (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_ewen(void)
{
	char cmd;

	cmd = 0x30;	//0x30́AWriteR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return 0;
}

//-----------------------------------------------------------------------------
// MicrowirefoCX̏ (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_erase(unsigned char adr)
{
	char cmd;

	cmd = (adr & 0x3f) | 0xC0;	//0xC0́AR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return 0;
}

//-----------------------------------------------------------------------------
// MicrowirefoCX̏݁A16rbg̃f[^ (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_write(unsigned char adr,unsigned char low,unsigned char hi)
{
	char cmd;

	cmd=(adr & 0x3f) | 0x40;	//0x04́AWriteR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	//f[^̏
	MCW_SendData(hi,8);
	MCW_SendData(low,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return ((unsigned int)(hi))<<8|low;
}

//-----------------------------------------------------------------------------
//	MicrowirefoCX̂`kk (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_eral(void)
{
	char cmd;

	cmd = 0x20;	//0x20́AALLR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return 0;
}

//-----------------------------------------------------------------------------
//	MicrowirefoCX̂`kk݁A16rbg̃f[^ (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_wral(unsigned char low ,unsigned char hi)
{
	char cmd;

	cmd = 0x10;	//0x10́AWriteALLR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	//f[^̏
	MCW_SendData(hi,8);
	MCW_SendData(low,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return ((unsigned int)(hi))<<8|low;
}

//-----------------------------------------------------------------------------
//	MicrowirefoCX̏ݖ (93C46pj
//-----------------------------------------------------------------------------
unsigned int MCW_EEP_ewds(void)
{
	char cmd;

	cmd = 0x00;	//0x30́AWriteR}h
	//MicrowirefoCX̎wAhXɃf[^
	//buff́A2bytẽobt@̃|C^iMicrowiréA16rbgANZX̂߁j
	//ANZXJn
	MCW_CsCnt(1);	//CS=H
	//X^[grbg̔s
	//ifoCXɂẮASB=1ɂȂOɂPNbNKvȂ߁A2NbNj
	MCW_SendData(0x40,2);
	//93C46́AAhXrbg6rbgAOP Code2rbg
	MCW_SendData(cmd,8);
	MCW_CsCnt(0);	//CS=L
//	for(i=0;i<20000;i++);	// 10ms
	return 0;
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_MODE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_ADR(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_READ(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_READ].DATA.WORD.W1 = 
				MCW_EEP_read(ICN[ID_MCW_ADR].DATA.BYTE.B1);	// f[^Ǐo
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_EWEN(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_ERASE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_WRITE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_ERAL(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_WRAL(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_MCW_EWDS(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_MODE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==0)
	{
		ICN[ID_MCW_MODE].DATA.BYTE.B1 = low;
		ICN[ID_MCW_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_MCW_MODE].DATA.WORD.W1)
		{
			ICN[ID_MODE].DATA.BYTE.B1 = ID_MCW_MODE;
			MCW_Init();
		}
	}
	else if(ICN[ID_MODE].DATA.BYTE.B1 == ID_MCW_MODE)
	{
		ICN[ID_MCW_MODE].DATA.BYTE.B1 = low;
		ICN[ID_MCW_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_MCW_MODE].DATA.WORD.W1==0)
		{
			ICN[ID_MODE].DATA.BYTE.B1	= 0;
			ICN[ID_P5_PU].DATA.BYTE.B1	= IO.PUCR5.BYTE;
			ICN[ID_P5_PC].DATA.BYTE.B1	= IO.PCR5;
			ICN[ID_P5_DI].DATA.BYTE.B1	= IO.PDR5.BYTE;
			ICN[ID_P5_DO].DATA.BYTE.B1	= IO.PDR5.BYTE;
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_ADR(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_ADR].DATA.BYTE.B1 = low;
		ICN[ID_MCW_ADR].DATA.BYTE.B2 = hi;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_READ(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_EWEN(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_EWEN].DATA.BYTE.B1 = 0x01;
		ICN[ID_MCW_EWEN].DATA.BYTE.B2 = 0x00;
		MCW_EEP_ewen();
	}

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_ERASE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_EWEN].DATA.BYTE.B1 = 0x00;
		ICN[ID_MCW_EWEN].DATA.BYTE.B2 = 0x00;
		MCW_EEP_erase(ICN[ID_MCW_ADR].DATA.BYTE.B1);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_WRITE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_WRITE].DATA.WORD.W1 = 
			MCW_EEP_write(ICN[ID_MCW_ADR].DATA.BYTE.B1,low,hi);	// f[^
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_ERAL(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_EWEN].DATA.BYTE.B1 = 0x00;
		ICN[ID_MCW_EWEN].DATA.BYTE.B2 = 0x00;
		MCW_EEP_eral();
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_WRAL(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_WRAL].DATA.WORD.W1 = MCW_EEP_wral(low,hi);// f[^
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_MCW_EWDS(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_MCW_MODE)
	{
		ICN[ID_MCW_EWEN].DATA.BYTE.B1 = 0x01;
		ICN[ID_MCW_EWEN].DATA.BYTE.B2 = 0x00;
		MCW_EEP_ewds();
	}
}
