//-----------------------------------------------------------------------------
//	ICN_h												A.Fukumori	2007/08/02
//-----------------------------------------------------------------------------
//	2006/11/19	A.Fukumori	
//	2006/11/21	A.Fukumori	ICN_READ->ICN_CALL, ICN_WRITE->ICN_SET, DATA Format
//	2007/01/14	A.Fukumori	ICN_DEFINE
//	2007/02/10	A.Fukumori	EXC DATA Format
//	2007/05/19	A.Fukumori	ICN_Open,ICN_Close̒ǉiCANUPC̓΍j
//	2007/05/24	A.Fukumori	CAN_
//	2007/05/26	A.Fukumori	JI
//	2007/06/02	A.Fukumori	ICNUPC̋ʉiICNNPA͐tō݉\j
//	2007/06/11	A.Fukumori	ICN_SendSC()̒ǉ
//	2007/07/01	A.Fukumori	TimeOutICN_TIMEOUT̃}N`ɏ]
//	2007/07/15	A.Fukumori	ICN_Status()̒ǉ
//	2007/08/02	A.Fukumori	inline unsigned int  inline unsigned short


#ifndef		_ICN_H_
#define		_ICN_H_

//#pragma comment(lib,"ifcan.lib")
//#pragma comment(lib,"ifcanpf.lib")

#define		ICN_TIMEOUT			500	// ^CAEg[ms]

//-----------------------------------------------------------------------------
//	ICN_(Macro)
//-----------------------------------------------------------------------------
#define		ICN_IF_MAX			2	// o^ő吔iICN_IF̔zTCYj

// ulBaudRate (Port Config Structure)
#define		ICN_BAUDRATE_500k	0x00000127
#define		ICN_BAUDRATE_1M		0x00000027

//-----------------------------------------------------------------------------
//	ICN_(BOX)
//-----------------------------------------------------------------------------
typedef struct
{
	struct
	{
		unsigned long	TX_Time	:32;		// Time
		unsigned long	RX_Time	:32;		// Time
		unsigned char	Enable	: 8;		// BYTEA
		unsigned char			: 8;		// BYTEB
		unsigned char			: 8;		// BYTEC
		unsigned char			: 8;		// BYTED

		union
		{
			struct
			{
				unsigned long	D1	:32;	// BYTE1,2,3,4
			}DWORD;

			struct
			{
				unsigned short	W1	:16;	// BYTE1,2
				unsigned short	W2	:16;	// BYTE3,4
			}WORD;

			struct
			{
				unsigned char	B1	: 8;	// BYTE1
				unsigned char	B2	: 8;	// BYTE2
				unsigned char	B3	: 8;	// BYTE3
				unsigned char	B4	: 8;	// BYTE4
			}BYTE;
		}DATA;
	}ID[256];	// ICN_Data
} ICN_BOX, *PICN_BOX;

//-----------------------------------------------------------------------------
//	IFCAN Message StructureiCAN_MESSAGEƓEEEj
//-----------------------------------------------------------------------------
typedef struct{
	ULONG	ulLength;
	ULONG	ulFlag;
	ULONG	ulID;
	BYTE	bData[8];
	ULONG	ulTime;
} IFCAN_MESSAGE, *PIFCAN_MESSAGE;

//-----------------------------------------------------------------------------
//	ICN_(Function)
//-----------------------------------------------------------------------------
extern			int				ICN_Open	(unsigned long	MAC,
											 char*			pName,
											 unsigned long	BaudRate,
											 char*			String	= "\0");
extern			int				ICN_Close	(unsigned long	MAC,
											 char*			String	= "\0");
extern			int				ICN_Status	(unsigned long	MAC);

//-----------------------------------------------------------------------------
//	ICN_Send_(Function)
//-----------------------------------------------------------------------------
extern	inline	int				ICN_Send	(unsigned long	MAC,
											 PIFCAN_MESSAGE	pMessage,
											 unsigned long	ulCount,
											 char*			String	= "\0");
extern	inline	int				ICN_Send_C	(unsigned long	MAC,
											 unsigned char	DATA_ID1,
											 unsigned char	DATA_ID2,
											 unsigned char	DATA_ID3,
											 char*			String	= "\0");
extern	inline	int				ICN_Send_CC	(unsigned long	MAC,
											 unsigned char	DATA_ID1,
											 unsigned char	DATA_ID2,
											 unsigned char	DATA_ID3,
											 unsigned char	DATA_ID4, 
											 unsigned char	DATA_ID5, 
											 unsigned char	DATA_ID6, 
											 char*			String	= "\0");
extern	inline	int				ICN_Send_CS (unsigned long	MAC, 
											 unsigned char	DATA_ID1, 
											 unsigned char	DATA_ID2, 
											 unsigned char	DATA_ID3, 
											 unsigned char	DATA_ID4, 
											 unsigned int	DATA1, 
											 char*			String	= "\0");
extern	inline	int				ICN_Send_SC (unsigned long	MAC, 
											 unsigned char	DATA_ID1, 
											 unsigned int	DATA1,
											 unsigned char	DATA_ID2, 
											 unsigned char	DATA_ID3, 
											 unsigned char	DATA_ID4, 
											 char*			String	= "\0");
extern	inline	int				ICN_Send_S	(unsigned long	MAC, 
											 unsigned char	DATA_ID1, 
											 unsigned int	DATA1, 
											 char*			String	= "\0");
extern	inline	int				ICN_Send_SS (unsigned long	MAC, 
											 unsigned char	DATA_ID1, 
											 unsigned int	DATA1, 
											 unsigned char	DATA_ID2, 
											 unsigned int	DATA2, 
											 char*			String	= "\0");

//-----------------------------------------------------------------------------
//	ICN_Get_(Function)
//-----------------------------------------------------------------------------
extern	inline	unsigned short	ICN_Get_WORD(unsigned long	MAC,
											 unsigned char	DATA_ID,
											 char*			String	= "\0");
extern	inline	unsigned long	ICN_Get_DWORD(unsigned long	MAC,
											 unsigned char	DATA_ID1,
											 unsigned char	DATA_ID2,
											 char*			String	= "\0");
#endif
